unit TestThreads;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

type

  { TTestThread }

  TTestThread = class(TThread)
  protected
    procedure Execute; override;
  public
    constructor Create;
  end;

  procedure Log(const AStr: String; AThreadId: TThreadID); inline;

implementation

procedure Log(const AStr: String; AThreadId: TThreadID);
begin
  WriteLn(AStr, ': ', ThreadID, ' - ', AThreadId);
end;

{ TTestThread }

procedure TTestThread.Execute;
begin
//  Sleep(1);
  Log('Execute', ThreadID);
end;

constructor TTestThread.Create;
begin
  inherited Create(True);
  FreeOnTerminate := True;
  Log('Create', ThreadID);
end;

end.

